关闭

嵌入式 python异常except语句用法与引发异常

1722人阅读 评论(0) 收藏 举报
分类:

except: #捕获所有异常

except: <异常名>: #捕获指定异常

except:<异常名1,异常名2):捕获异常1或者异常2

except:<异常名>,<数据>:捕获指定异常及其附加的数据

except:<异常名1,异常名2>:<数据>:捕获异常名1或者异常名2,及附加的数据库

常用异常名:

异常名    描述
AttributeError 调用不存在的方法引发的异常
EOFError    遇到文件末尾引发的异常
ImportError 导入模块出错引发的异常
IndexError    列表越界引发的异常
IOError    I/O操作引发的异常,如打开文件出错等
KeyError  使用字典中不存在的关键字引发的异常
NameError 使用不存在的变量名引发的异常
TabError 语句块缩进不正确引发的异常
ValueError 搜索列表中不存在的值引发的异常
ZeroDivisionError   除数为零引发的异常

使用raise 引发异常几种方式:

raise 异常名
raise 异常名,附加数据
raise 类名

assert 简化了raise语句:
需要注意的是,assert语句一般用于开发时对程序条件的验证,只有当内置_debug_为True时,assert语句才有效。当Python脚本以-O选项编译成为字节码文件时,assert语句将被移除。
但与raise语句不同的是,assert语句是在条件测试为假时,才引发异常。assert语言的一般形式如下:

assert<条件测试>,<异常附加数据>#其中异常附加数据是可选的

python编程_Python异常机制try: 代码段except 异常类型,e: 异常处理代码段,如果不知道异常类型,可以使用try: 代码段 exceptExcept,e:异常处理代码段;Except是通用异常类型 

 

一个Python异常实例

 

一个简单的异常例子,打开一个不存在的文件,引发异常:

#!/usr/local/bin/python3.2    
try:
    f = open("file-not-exists", "r")  
except IOError,e:
    print("open exception: %s: %s\n" %(e.errno, e.strerror))  
与Python异常相关的关键字:
关键字          关键字说明
raise           抛出/引发异常
try/except      捕获异常并处理
pass            忽略异常
as              定义异常实例(except IOError as e)
finally         无论是否出现异常,都执行的代码
else            如果try中的语句没有引发异常,则执行else中的语句
except
   老版本的Python,except语句写作"except Exception, e",Python 2.6后应写作"except Exception as e"。
使用

except

而不带任何异常类型:
try:

     do something

except:

      handleexcept

    会捕获所有异常,包括键盘中断和程序退出请求(用sys.exit()就无法退出程序了,因为异常被捕获了),因此慎用。
使用

except Exception as e

可以捕获除与程序退出sys.exit()相关之外的所有异常
 
 
else与finally
 
else表示如果try中的代码没有引发异常,则会执行else:
try:
    f = open("foo", "r")
except IOError as e:
    ...
else:
    data = f.read()
 
finally表示无论是否有异常,都将被执行:
try:
    f = open("foo", "r")
except IOError as e:
    ...
finally:
    f.close()

 

 

#!/usr/bin/python

import traceback
try:
 1/0
#except Exception,e:
print traceback.format_exc()
 
except Exception as e:
 print e

#!/usr/bin/python
import traceback
try:
 1/0
#except Exception,e:
print traceback.format_exc()
 
except Exception , e:
 print e

      Python的异常处理能力是很强大的,可向用户准确反馈出错信息。在Python中,异常也是对象,可对它进行操作。所有异常都是基类Exception的成员。所有异常都从基类Exception继承,而且都在exceptions模块中定义。Python自动将所有异常名称放在内建命名空间中,所以程序不必导入exceptions模块即可使用异常。一旦引发而且没有捕捉SystemExit异常,程序执行就会终止。如果交互式会话遇到一个未被捕捉的SystemExit异常,会话就会终止。

方式一:try语句:

1使用try和except语句来捕获异常

try:
   block
except [exception,[data…]]:
   block

try:
block
except [exception,[data...]]:
   block
else:
   block

该种异常处理语法的规则是:

·  执行try下的语句,如果引发异常,则执行过程会跳到第一个except语句。

·  如果第一个except中定义的异常与引发的异常匹配,则执行该except中的语句。

·  如果引发的异常不匹配第一个except,则会搜索第二个except,允许编写的except数量没有限制。

·  如果所有的except都不匹配,则异常会传递到下一个调用本代码的最高层try代码中。

·   如果没有发生异常,则执行else块代码。

例:

try:

   f =open(“file.txt”,”r”)
except IOError, e:
   print e

捕获到的IOError错误的详细原因会被放置在对象e中,然后运行该异常的except代码块

捕获所有的异常

try:
   a=b
   b=c
except Exception,ex:
   print Exception,":",ex

使用except子句需要注意的事情,就是多个except子句截获异常时,如果各个异常类之间具有继承关系,则子类应该写在前面,否则父类将会直接截获子类异常。放在后面的子类异常也就不会执行到了。

2 使用try跟finally:

语法如下:

try:
   block
finally:
   block

该语句的执行规则是:

·   执行try下的代码。

·  如果发生异常,在该异常传递到下一级try时,执行finally中的代码。

·  如果没有发生异常,则执行finally中的代码。

第二种try语法在无论有没有发生异常都要执行代码的情况下是很有用的。例如我们在python中打开一个文件进行读写操作,我在操作过程中不管是否出现异常,最终都是要把该文件关闭的。

这两种形式相互冲突,使用了一种就不允许使用另一种,而功能又各异

2. 用raise语句手工引发一个异常:

raise [exception[,data]]

在Python中,要想引发异常,最简单的形式就是输入关键字raise,后跟要引发的异常的名称。异常名称标识出具体的类:Python异常是那些类的对象。执行raise语句时,Python会创建指定的异常类的一个对象。raise语句还可指定对异常对象进行初始化的参数。为此,请在异常类的名称后添加一个逗号以及指定的参数(或者由参数构成的一个元组)。

例:

try:
    raiseMyError #自己抛出一个异常
except MyError:
    print 'aerror'

raise ValueError,’invalid argument’
捕捉到的内容为:

type = VauleError
message = invalid argument

3.   采用traceback(跟踪)模块查看异常

     发生异常时,Python能“记住”引发的异常以及程序的当前状态。Python还维护着traceback(跟踪)对象,其中含有异常发生时与函数调用堆栈有关的信息。记住,异常可能在一系列嵌套较深的函数调用中引发。程序调用每个函数时,Python会在“函数调用堆栈”的起始处插入函数名。一旦异常被引发,Python会搜索一个相应的异常处理程序。如果当前函数中没有异常处理程序,当前函数会终止执行,Python会搜索当前函数的调用函数,并以此类推,直到发现匹配的异常处理程序,或者Python抵达主程序为止。这一查找合适的异常处理程序的过程就称为“堆栈辗转开解”(StackUnwinding)。解释器一方面维护着与放置堆栈中的函数有关的信息,另一方面也维护着与已从堆栈中“辗转开解”的函数有关的信息。

   格式:

try:
block
except:
   traceback.print_exc()

示例:…excpetion/traceback.py

4. 采用sys模块回溯最后的异常

import sys
try:
   block
except:
   info=sys.exc_info()
   print info[0],":",info[1]

或者以如下的形式:

import sys
    tp,val,td =sys.exc_info()

sys.exc_info()的返回值是一个tuple, (type, value/message, traceback)

这里的type ---- 异常的类型

value/message ---- 异常的信息或者参数

traceback ---- 包含调用栈信息的对象。

从这点上可以看出此方法涵盖了traceback.

5. 异常处理的一些其它用途

      除了处理实际的错误条件之外,对于异常还有许多其它的用处。在标准 Python库中一个普通的用法就是试着导入一个模块,然后检查是否它能使用。导入一个并不存在的模块将引发一个 ImportError异常。你可以使用这种方法来定义多级别的功能――依靠在运行时哪个模块是有效的,或支持多种平台(即平台特定代码被分离到不同的模块中)。

      你也能通过创建一个从内置的 Exception 类继承的类定义你自己的异常,然后使用 raise命令引发你的异常。如果你对此感兴趣,请看进一步阅读的部分。

     下面的例子演示了如何使用异常支持特定平台功能。代码来自 getpass 模块,一个从用户获得口令的封装模块。获得口令在UNIX、Windows 和 Mac OS 平台上的实现是不同的,但是这个代码封装了所有的不同之处。

例支持特定平台功能

# Bind the name getpass to the appropriate function

try:
     import termios,TERMIOS                   
except ImportError:
     try:
         importmsvcrt                         
     except ImportError:
         try:
             from EasyDialogs import AskPassword
         except ImportError:
             getpass =default_getpass         
         else:                                 
             getpass = AskPassword
     else:
         getpass = win_getpass
else:
     getpass = unix_getpass

   

      termios 是 UNIX 独有的一个模块,它提供了对于输入终端的底层控制。如果这个模块无效(因为它不在你的系统上,或你的系统不支持它),则导入失败,Python 引发我们捕捉的 ImportError 异常。

   

      OK,我们没有 termios,所以让我们试试 msvcrt,它是 Windows 独有的一个模块,可以提供在 MicrosoftVisual C++ 运行服务中的许多有用的函数的一个API。如果导入失败,Python 会引发我们捕捉的 ImportError异常。

   

如果前两个不能工作,我们试着从 EasyDialogs 导入一个函数,它是 Mac OS独有的一个模块,提供了各种各样类型的弹出对话框。再一次,如果导入失败,Python 会引发一个我们捕捉的 ImportError异常。

   

      这些平台特定的模块没有一个有效 (有可能,因为 Python已经移植到了许多不同的平台上了),所以我们需要回头使用一个缺省口令输入函数 (这个函数定义在 getpass模块中的别的地方)。注意我们在这里所做的:我们将函数 default_getpass 赋给变量 getpass。如果你读了官方getpass 文档,它会告诉你 getpass 模块定义了一个 getpass 函数。它是这样做的:通过绑定 getpass到正确的函数来适应你的平台。然后当你调用 getpass函数时,你实际上调用了平台特定的函数,是这段代码已经为你设置好的。你不需要知道或关心你的代码正运行在何种平台上;只要调用getpass,则它总能正确处理。

   

      一个 try...except 块可以有一条 else 子句,就像 if 语句。如果在 try 块中没有异常引发,然后 else子句被执行。在本例中,那就意味着如果 from EasyDialogs import AskPassword导入可工作,所以我们应该绑定 getpass 到 AskPassword 函数。其它每个 try...except 块有着相似的else 子句,当我们发现一个 import 可用时,就绑定 getpass 到适合的函数。

 

0
0

查看评论
* 以上用户言论只代表其个人观点,不代表CSDN网站的观点或立场
    个人资料
    • 访问:1041023次
    • 积分:18215
    • 等级:
    • 排名:第522名
    • 原创:741篇
    • 转载:522篇
    • 译文:0篇
    • 评论:106条
    最新评论